Bug 580480 - Review Request: ghc-type-level - A type-level library for Haskell
Review Request: ghc-type-level - A type-level library for Haskell
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jens Petersen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-04-08 07:27 EDT by Shakthi Kannan
Modified: 2010-12-06 19:38 EST (History)
3 users (show)

See Also:
Fixed In Version: ghc-type-level-0.2.4-2.fc13
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-09-10 23:43:41 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
petersen: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)
patch to update to cabal2spec-0.22.2 (1.20 KB, patch)
2010-08-19 00:06 EDT, Jens Petersen
no flags Details | Diff

  None (edit)
Description Shakthi Kannan 2010-04-08 07:27:16 EDT
Spec URL: http://shakthimaan.fedorapeople.org/SPECS/ghc-type-level.spec
SRPM URL: http://shakthimaan.fedorapeople.org/SRPMS/ghc-type-level-0.2.4-1.fc12.src.rpm
Description: A type-level library for Haskell
Comment 1 Shakthi Kannan 2010-04-08 07:34:08 EDT
$ rpmlint -iv ghc-type-level.spec ../SRPMS/ghc-type-level-0.2.4-1.fc12.src.rpm ../RPMS/i686/ghc-type-level-*
ghc-type-level.src: I: checking
ghc-type-level.i686: I: checking
ghc-type-level.i686: W: unstripped-binary-or-object /usr/lib/ghc-6.12.1/type-level-0.2.4/libHStype-level-0.2.4-ghc6.12.1.so
ghc-type-level.i686: W: executable-stack /usr/lib/ghc-6.12.1/type-level-0.2.4/libHStype-level-0.2.4-ghc6.12.1.so
The binary declares the stack as executable.  Executable stack is usually an
error as it is only needed if the code contains GCC trampolines or similar
constructs which uses code on the stack.  One common source for needlessly
executable stack cases are object files built from assembler files which don't
define a proper .note.GNU-stack section.

ghc-type-level-devel.i686: I: checking
ghc-type-level-devel.i686: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

ghc-type-level-doc.i686: I: checking
ghc-type-level-prof.i686: I: checking
ghc-type-level-prof.i686: E: devel-dependency ghc-type-level-devel
Your package has a dependency on a devel package but it's not a devel package
itself.

ghc-type-level-prof.i686: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

ghc-type-level-prof.i686: W: devel-file-in-non-devel-package /usr/lib/ghc-6.12.1/type-level-0.2.4/libHStype-level-0.2.4_p.a
A development file (usually source code) is located in a non-devel package. If
you want to include source code in your package, be sure to create a
development package.

5 packages and 1 specfiles checked; 1 errors, 5 warnings.
Comment 2 Shakthi Kannan 2010-04-08 07:45:40 EDT
Successful Koji builds for F-13 and F14, respectively:

http://koji.fedoraproject.org/koji/taskinfo?taskID=2102434
http://koji.fedoraproject.org/koji/taskinfo?taskID=2102431
Comment 3 Jens Petersen 2010-07-05 02:52:50 EDT
For reference: type-level is needed by ForSyDe.
Comment 4 Jens Petersen 2010-07-13 09:50:30 EDT
Do you mind updating the package to latest cabal2spec?
Comment 5 Shakthi Kannan 2010-07-13 11:03:30 EDT
Done!

SPEC: http://shakthimaan.fedorapeople.org/SPECS/ghc-type-level.spec
SRPM: http://shakthimaan.fedorapeople.org/SRPMS/ghc-type-level-0.2.4-2.fc14.src.rpm

$ rpmlint ghc-type-level.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$ rpmlint ghc-type-level-0.2.4-2.fc14.i686.rpm 
ghc-type-level.i686: W: spelling-error Summary(en_US) Haskell -> Harrell, Rathskeller, Hastily
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

$ rpmlint ghc-type-level-devel-0.2.4-2.fc14.i686.rpm 
ghc-type-level-devel.i686: W: spelling-error Summary(en_US) Haskell -> Harrell, Rathskeller, Hastily
ghc-type-level-devel.i686: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

$ rpmlint ghc-type-level-doc-0.2.4-2.fc14.i686.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

 $ rpmlint ghc-type-level-prof-0.2.4-2.fc14.i686.rpm 
ghc-type-level-prof.i686: E: devel-dependency ghc-type-level-devel
ghc-type-level-prof.i686: W: no-documentation
ghc-type-level-prof.i686: W: devel-file-in-non-devel-package /usr/lib/ghc-6.12.3/type-level-0.2.4/libHStype-level-0.2.4_p.a
1 packages and 0 specfiles checked; 1 errors, 2 warnings.

Successful Koji builds for F-13, F-14 respectively:

http://koji.fedoraproject.org/koji/taskinfo?taskID=2316562
http://koji.fedoraproject.org/koji/taskinfo?taskID=2316569
Comment 6 Jens Petersen 2010-08-19 00:04:29 EDT
The changelog should really be in your name.
Comment 7 Jens Petersen 2010-08-19 00:06:32 EDT
Created attachment 439575 [details]
patch to update to cabal2spec-0.22.2

Update the packaging to cabal2spec-0.22.2 (available in F14).
Comment 8 Shakthi Kannan 2010-08-19 11:06:52 EDT
Regarding the patch, it is asking for hscolour to be installed even though it is mentioned as:

  %bcond_without hscolour

Why is it so?
Comment 10 Jens Petersen 2010-08-19 19:46:53 EDT
(In reply to comment #8)
> Regarding the patch, it is asking for hscolour to be installed even though it
> is mentioned as:
> 
>   %bcond_without hscolour

bcond is a little confusing: basically above means define
a "--without hscolour" cmdline option for rpmbuild for this package.
So to the packager better to think of the opposite as the default.
hscolour is still a bit experimental: probably later it
will be made default and above line will become superfluous.
Comment 11 Jens Petersen 2010-08-19 19:49:46 EDT
(Further hscolour is being used to provide colored source links
from haddock documentation in case it wasn't obvious. :)
Comment 12 Jens Petersen 2010-08-19 21:14:45 EDT
(In reply to comment #9)
> Updated:

Thanks

> SPEC: http://shakthimaan.fedorapeople.org/SPECS/ghc-type-level.spec 

I think you forgot actually to update this. :)

> SRPM:
> http://shakthimaan.fedorapeople.org/SRPMS/ghc-type-level-0.2.4-3.fc15.src.rpm

BTW since there are no deps you could remove the references
ghc_pkg_deps and ghc_pkg_c_deps if you wish.

Otherwise the package looks fine to me.
I will post a format review soon.
Comment 13 Shakthi Kannan 2010-08-20 13:07:58 EDT
The package was/is updated now with removal of ghc_pkg_deps, and ghc_pkg_c_deps. Please do refresh on your browser or clear the cache. Thanks.

SPEC: http://shakthimaan.fedorapeople.org/SPECS/ghc-type-level.spec
SRPM: http://shakthimaan.fedorapeople.org/SRPMS/ghc-type-level-0.2.4-4.fc15.src.rpm
Comment 14 Jens Petersen 2010-08-31 03:33:41 EDT
Thanks, here is the final review:

 +:ok, =:needs attention, -:needs fixing,  NA: not applicable

MUST Items:
[] MUST: rpmlint output

ghc-type-level.src: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
ghc-type-level.x86_64: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
ghc-type-level.x86_64: W: executable-stack /usr/lib64/ghc-6.12.1/type-level-0.2.4/libHStype-level-0.2.4-ghc6.12.1.so
1 packages and 0 specfiles checked; 0 errors, 2 warnings.
ghc-type-level-devel.x86_64: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
ghc-type-level-prof.x86_64: E: devel-dependency ghc-type-level-devel
ghc-type-level-prof.x86_64: W: no-documentation
ghc-type-level-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.12.1/type-level-0.2.4/libHStype-level-0.2.4_p.a
1 packages and 0 specfiles checked; 1 errors, 2 warnings.

All standard and waived

[+] MUST: Package Naming Guidelines
[+] MUST: spec file name must match base package %{name}
[+] MUST: Packaging Guidelines.
[+] MUST: Licensing Guidelines
[+] MUST: License field in the package spec file must match actual license.
[+] MUST: include license files in %doc if available in source
[+] MUST: The spec file must be written in American English and be legible.
[+] MUST: source md5sum matches upstream release

4aca3b4fd0a56377ffa79464cf491509  type-level-0.2.4.tar.gz

[+] MUST: must successfully compile and build into binary rpms on one main arch

http://koji.fedoraproject.org/koji/taskinfo?taskID=2436860

[+] MUST: if necessary use ExcludeArch for other archs
[+] MUST: All build dependencies must be listed in BuildRequires
[NA] MUST: packages which store shared library files in the dynamic linker's default paths, must call ldconfig in %post and %postun.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A package must not contain any duplicate files in the %files listing.
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[+] MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines.

Only minimal differences to cabal2spec template.

[+] MUST: The package must contain code, or permissable content.
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[+] MUST: Header files must be in a -devel package.
[NA] MUST: Static libraries must be in a -static package.
[NA] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[+] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} 
[+] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.

SHOULD Items:
[+] SHOULD: The reviewer should test that the package builds in mock.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane.
[+] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.

Package is APPROVED.
Comment 15 Shakthi Kannan 2010-08-31 12:26:59 EDT
New Package SCM Request
=======================
Package Name: ghc-type-level
Short Description: Haskell type-level library
Owners: shakthimaan chitlesh
Branches: F-13 F-14
Comment 16 Kevin Fenzi 2010-09-01 15:28:17 EDT
Git done (by process-git-requests).
Comment 17 Fedora Update System 2010-09-02 12:16:17 EDT
ghc-type-level-0.2.4-2.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/ghc-type-level-0.2.4-2.fc13
Comment 18 Fedora Update System 2010-09-02 12:16:22 EDT
ghc-type-level-0.2.4-4.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/ghc-type-level-0.2.4-4.fc14
Comment 19 Fedora Update System 2010-09-02 16:50:01 EDT
ghc-type-level-0.2.4-2.fc13 has been pushed to the Fedora 13 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update ghc-type-level'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/ghc-type-level-0.2.4-2.fc13
Comment 20 Fedora Update System 2010-09-10 23:43:36 EDT
ghc-type-level-0.2.4-4.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 21 Fedora Update System 2010-09-11 04:57:16 EDT
ghc-type-level-0.2.4-2.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 22 Jens Petersen 2010-12-04 06:38:07 EST
You forgot to request "InitialCC: haskell-sig".
Comment 23 Jens Petersen 2010-12-06 19:38:04 EST
> You forgot to request "InitialCC: haskell-sig".

added

Note You need to log in before you can comment on or make changes to this bug.